41a25a400f4810adca71abc24ede4f2630c8200d
[openwrt.git] / package / madwifi / files / lib / wifi / madwifi.sh
1 #!/bin/sh
2 append DRIVERS "atheros"
3
4 scan_atheros() {
5         local device="$1"
6         local wds
7         local adhoc sta ap
8         
9         config_get vifs "$device" vifs
10         for vif in $vifs; do
11         
12                 config_get ifname "$vif" ifname
13                 config_set "$vif" ifname "${ifname:-ath}"
14                 
15                 config_get mode "$vif" mode
16                 case "$mode" in
17                         adhoc|ahdemo|sta|ap)
18                                 append $mode "$vif"
19                         ;;
20                         wds)
21                                 config_get addr "$vif" bssid
22                                 config_get ssid "$vif" ssid
23                                 [ -z "$addr" -a -n "$ssid" ] && {
24                                         config_set "$vif" wds 1
25                                         config_set "$vif" mode sta
26                                         mode="sta"
27                                         addr="$ssid"
28                                 }
29                                 ${addr:+append $mode "$vif"}
30                         ;;
31                         *) echo "$device($vif): Invalid mode, ignored."; continue;;
32                 esac
33         done
34
35         case "${adhoc:+1}:${sta:+1}:${ap+1}" in
36                 # valid mode combinations
37                 1::) wds="";;
38                 1::1);;
39                 :1:1)config_set "$device" nosbeacon 1;; # AP+STA, can't use beacon timers for STA
40                 :1:);;
41                 ::1);;
42                 ::);;
43                 *) echo "$device: Invalid mode combination in config"; return 1;;
44         esac
45
46         config_set "$device" vifs "${ap:+$ap }${adhoc:+$adhoc }${ahdemo:+$ahdemo }${sta:+$sta }${wds:+$wds }"
47 }
48
49
50 disable_atheros() (
51         local device="$1"
52
53         set_wifi_down "$device"
54         # kill all running hostapd and wpa_supplicant processes that
55         # are running on atheros vifs 
56         for pid in `pidof hostapd wpa_supplicant`; do
57                 grep ath /proc/$pid/cmdline >/dev/null && \
58                         kill $pid
59         done
60         
61         include /lib/network
62         cd /proc/sys/net
63         for dev in *; do
64                 grep "$device" "$dev/%parent" >/dev/null 2>/dev/null && {
65                         ifconfig "$dev" down 
66                         unbridge "$dev"
67                         wlanconfig "$dev" destroy
68                 }
69         done
70         return 0
71 )
72
73 enable_atheros() {
74         local device="$1"
75         config_get channel "$device" channel
76         config_get vifs "$device" vifs
77         
78         local first=1
79         for vif in $vifs; do
80                 nosbeacon=
81                 config_get ifname "$vif" ifname
82                 config_get enc "$vif" encryption
83                 config_get mode "$vif" mode
84                 
85                 [ "$mode" = sta ] && config_get nosbeacon "$device" nosbeacon
86                 
87                 config_get ifname "$vif" ifname
88                 ifname=$(wlanconfig "$ifname" create wlandev "$device" wlanmode "$mode" ${nosbeacon:+nosbeacon})
89                 [ $? -ne 0 ] && {
90                         echo "enable_atheros($device): Failed to set up $mode vif $ifname" >&2
91                         continue
92                 }
93                 config_set "$vif" ifname "$ifname"
94
95                 [ "$first" = 1 ] && {
96                         # only need to change freq band and channel on the first vif
97                         config_get agmode "$device" agmode
98                         pureg=0
99                         case "$agmode" in
100                                 *b) agmode=11b;;
101                                 *bg) agmode=11g;;
102                                 *g) agmode=11g; pureg=1;;
103                                 *a) agmode=11a;;
104                                 *) agmode=auto;;
105                         esac
106                         iwconfig "$ifname" channel "$channel" >/dev/null 2>/dev/null 
107                         ifconfig "$ifname" up
108                         sleep 1
109                         iwpriv "$ifname" mode "$agmode"
110                         iwpriv "$ifname" pureg "$pureg"
111                         iwconfig "$ifname" channel "$channel" >/dev/null 2>/dev/null 
112                 }
113         
114                 config_get_bool hidden "$vif" hidden 0
115                 iwpriv "$ifname" hide_ssid "$hidden"
116
117                 config_get_bool ff "$vif" ff 0
118                 iwpriv "$ifname" ff "$ff"
119
120                 config_get wds "$vif" wds
121                 case "$wds" in
122                         1|on|enabled) wds=1;;
123                         *) wds=0;;
124                 esac
125                 iwpriv "$ifname" wds "$wds"
126
127                 wpa=
128                 case "$enc" in
129                         WEP|wep)
130                                 for idx in 1 2 3 4; do
131                                         config_get key "$vif" "key${idx}"
132                                         iwconfig "$ifname" enc "[$idx]" "${key:-off}"
133                                 done
134                                 config_get key "$vif" key
135                                 key="${key:-1}"
136                                 case "$key" in
137                                         [1234]) iwconfig "$ifname" enc "[$key]";;
138                                         *) iwconfig "$ifname" enc "$key";;
139                                 esac
140                         ;;
141                         PSK|psk|PSK2|psk2)
142                                 config_get key "$vif" key
143                         ;;
144                 esac
145
146                 case "$mode" in
147                         wds)
148                                 config_get addr "$vif" bssid
149                                 iwpriv "$ifname" wds_add "$addr"
150                         ;;
151                         adhoc|ahdemo)
152                                 config_get addr "$vif" bssid
153                                 [ -z "$addr" ] || { 
154                                         iwconfig "$ifname" ap "$addr"
155                                 }
156                         ;;
157                 esac
158                 config_get ssid "$vif" ssid
159
160                 config_get_bool bgscan "$vif" bgscan 0
161                 iwpriv "$ifname" bgscan "$bgscan"
162
163                 config_get_bool antdiv "$device" diversity 1
164                 sysctl -w dev."$device".diversity="$antdiv" >&-
165
166                 config_get antrx "$device" rxantenna
167                 if [ -n "$antrx" ]; then
168                         sysctl -w dev."$device".rxantenna="$antrx" >&-
169                 fi
170
171                 config_get anttx "$device" txantenna
172                 if [ -n "$anttx" ]; then
173                         sysctl -w dev."$device".txantenna="$anttx" >&-
174                 fi
175
176                 config_get distance "$device" distance
177                 if [ -n "$distance" ]; then
178                         athctrl -i "$device" -d "$distance" >&-
179                 fi
180
181                 config_get txpwr "$vif" txpower
182                 if [ -n "$txpwr" ]; then
183                         iwconfig "$ifname" txpower "${txpwr%%.*}"
184                 fi
185
186                 config_get frag "$vif" frag
187                 if [ -n "$frag" ]; then
188                         iwconfig "$ifname" frag "${frag%%.*}"
189                 fi
190
191                 config_get rts "$vif" rts
192                 if [ -n "$rts" ]; then
193                         iwconfig "$ifname" rts "${rts%%.*}"
194                 fi
195
196                 ifconfig "$ifname" up
197                 iwconfig "$ifname" channel "$channel" >/dev/null 2>/dev/null 
198
199                 local net_cfg bridge
200                 net_cfg="$(find_net_config "$vif")"
201                 [ -z "$net_cfg" ] || {
202                         bridge="$(bridge_interface "$net_cfg")"
203                         config_set "$vif" bridge "$bridge"
204                         start_net "$ifname" "$net_cfg"
205                 }
206                 iwconfig "$ifname" essid "$ssid"
207                 set_wifi_up "$vif" "$ifname"
208                 case "$mode" in
209                         ap)
210                                 config_get_bool isolate "$vif" isolate 0
211                                 iwpriv "$ifname" ap_bridge "$((isolate^1))"
212
213                                 if eval "type hostapd_setup_vif" 2>/dev/null >/dev/null; then
214                                         hostapd_setup_vif "$vif" madwifi || {
215                                                 echo "enable_atheros($device): Failed to set up wpa for interface $ifname" >&2
216                                                 # make sure this wifi interface won't accidentally stay open without encryption
217                                                 ifconfig "$ifname" down
218                                                 wlanconfig "$ifname" destroy
219                                                 continue
220                                         }
221                                 fi
222                         ;;
223                         wds|sta)
224                                 case "$enc" in 
225                                         PSK|psk|PSK2|psk2)
226                                                 case "$enc" in
227                                                         PSK|psk)
228                                                                 proto='proto=WPA'
229                                                                 passphrase="${key}"
230                                                                 ;;
231                                                         PSK2|psk2)
232                                                                 proto='proto=RSN'
233                                                                 passphrase=`wpa_passphrase ${ssid} "${key}" | grep psk | grep -v \#| cut -d= -f2`
234                                                                 ;;
235                                                 esac
236                                                 
237                                                 cat > /var/run/wpa_supplicant-$ifname.conf <<EOF
238 ctrl_interface=/var/run/wpa_supplicant
239 network={
240         scan_ssid=1
241         ssid="$ssid"
242         key_mgmt=WPA-PSK
243         $proto
244         psk="$passphrase"
245 }
246 EOF
247                                         ;;
248                                         WPA|wpa|WPA2|wpa2)
249                                                 #add wpa_supplicant calls here
250                                         ;;
251                                 esac
252                                 [ -z "$proto" ] || wpa_supplicant ${bridge:+ -b $bridge} -B -D wext -i "$ifname" -c /var/run/wpa_supplicant-$ifname.conf
253                         ;;
254                 esac
255                 first=0
256         done
257 }
258
259
260 detect_atheros() {
261         cd /proc/sys/dev
262         [ -d ath ] || return
263         for dev in $(ls -d wifi* 2>&-); do
264                 config_get type "$dev" type
265                 [ "$type" = atheros ] && return
266                 cat <<EOF
267 config wifi-device  $dev
268         option type     atheros
269         option channel  5
270
271         # REMOVE THIS LINE TO ENABLE WIFI:
272         option disabled 1
273
274 config wifi-iface
275         option device   $dev
276         option network  lan
277         option mode     ap
278         option ssid     OpenWrt
279         option encryption none
280 EOF
281         done
282 }